Subject: [PATCH] ARM: imx25-pinfunc: remove SION from all modes

From: [email-masked] (Shawn Guo)
Date: Thu, 16 Jun 2016 08:32:25 +0800

On Mon, Jun 13, 2016 at 12:16:16PM +0200, Uwe Kleine-K?nig wrote:
> Hello Shawn,
> 
> On Fri, Jun 03, 2016 at 09:31:48PM +0200, Uwe Kleine-K?nig wrote:
> > On Fri, Jun 03, 2016 at 10:01:07PM +0800, Shawn Guo wrote:
> > > On Fri, Jun 03, 2016 at 03:32:47PM +0200, Uwe Kleine-K?nig wrote:
> > > > I found a regression of the patch under discussion (which was not
> > > > applied, so no big problem). On the custom mx25 based hardware an
> > > > SD-card isn't detected any more after removing SION from
> > > > MX25_PAD_SD1_CMD__SD1_CMD. I verified the same happens on a tx25.
> > > > 
> > > > Is this expected? IMHO it's unfortunate (if not a silicon bug) that you
> > > > need the SION bit here as the SION bit has some more side effects.  If
> > > > you ask me, muxing a certain function for a pin should enable the input
> > > > path to the respective module if the pin is bidirectional.
> > > > 
> > > > Is there a list of pin/function pairs that need the SION bit set? Shawn,
> > > > would you agree to accept this patch with the high risk that it
> > > > introduces regressions? Or maybe we should make the SION bit more easily
> > > > overridable for board dts files (and default to off unless known it's
> > > > needed)?
> > > 
> > > I would be conservative on this.  Can we just fix the SION bits that are
> > > known doing harm?
> > 
> > I didn't do any measurements, but I'd expect that every SION bit that is
> > set without good reason increases current consumption. So each SION bit
> > does some harm. Plus debugging a missing SION bit is much easier than a
> > SION bit that is set without need.
> > 
> > The first problem I debugged was an UART problem and the SION bit had to
> > be removed from MX25_PAD_KPP_ROW3__GPIO_3_0 (plus back then
> > MX25_PAD_KPP_ROW3__UART1_RI wasn't defined). The problem I had now was a
> > broken SD card and I had to add SION to MX25_PAD_SD1_CMD__SD1_CMD.
> > 
> > So I expect my commit to (maybe) introduce some obvious and easy to
> > debug regressions and to (probably) fix some harder to debug and not so
> > obvious problems. I'd say it's a net win.
> 
> I didn't hear anything back from you on this topic. So I created a patch
> that documents that SION is needed for MX25_PAD_SD1_CMD__SD1_CMD and
> then rebased the patch under discussion on top of that. I will send the
> resulting patches as reply to this mail. IMHO the first patch should not
> be controversal.
> 
> I still think that the second patch is a good one, did your view change?

Okay, I chose to trust you and applied both patches :)

Shawn